
#undef FALSE
#undef TRUE

#define FIND_A 0
#define FIND_B 1
#define FIND_AB 2
#define FIND_AG 3
#define FIND_AUTO 4
#define FIND_BG 5
#define FIND_BaG 6
#define FIND_BsG 7
#define FIND_Ba 8
#define FIND_Bs 9
#define FIND_G 10 \

#define RELATIVE 0
#define ABSOLUTE 1 \

#define COLLIMATED 0
#define DIFFUSE 1 \

#define FALSE 0
#define TRUE 1 \

#define IAD_MAX_ITERATIONS 5000 \

#define IAD_NO_ERROR 0 \

#define IAD_TOO_MANY_ITERATIONS 1 \

#define IAD_R_LT_ZERO 2
#define IAD_R_GT_ONE 3
#define IAD_T_LT_ZERO 4
#define IAD_T_GT_ONE 5
#define IAD_TU_LT_ZERO 6
#define IAD_TU_GT_ONE 7 \

#define IAD_R_PLUS_T_GT_ONE 8
#define IAD_RD_IS_ZERO_BUT_NOT_TD 9
#define IAD_TD_LT_ZERO 10 \

#define IAD_RD_LT_ZERO 11
#define IAD_RT_GT_ONE 12
#define IAD_TT_GT_ONE 13
#define IAD_RT_PLUS_TT_GT_ONE 14
#define IAD_R_PLUS_T_PLUS_TU_GT_ONE 15 \

#define IAD_AS_NOT_VALID 16
#define IAD_AE_NOT_VALID 17
#define IAD_AD_NOT_VALID 18
#define IAD_RW_NOT_VALID 19
#define IAD_RD_NOT_VALID 20
#define IAD_RSTD_NOT_VALID 21 \

#define IAD_GAMMA_NOT_VALID 22
#define IAD_F_NOT_VALID 23
#define IAD_BAD_PHASE_FUNCTION 24 \

#define IAD_QUAD_PTS_NOT_VALID 25
#define IAD_BAD_G_VALUE 26
#define IAD_TOO_MANY_LAYERS 27 \

#define IAD_MEMORY_ERROR 28
#define IAD_FILE_ERROR 29 \

#define IAD_EXCESSIVE_LIGHT_LOSS 30
#define IAD_RT_LT_MINIMUM 31 \

#define UNINITIALIZED -99 \

#define DEBUG_A_LITTLE 1
#define DEBUG_GRID 2
#define DEBUG_ITERATIONS 4
#define DEBUG_LOST_LIGHT 8
#define DEBUG_SPHERE_EFFECTS 16
#define DEBUG_BEST_GUESS 32
#define DEBUG_EVERY_CALC 64
#define DEBUG_SEARCH 128
#define DEBUG_RD_ONLY 256
#define DEBUG_ANY 0xFFFFFFFF \





typedef struct measure_type
{
  double slab_index;
  double slab_thickness;

  double slab_top_slide_index;
  double slab_top_slide_b;
  double slab_top_slide_thickness;

  double slab_bottom_slide_index;
  double slab_bottom_slide_b;
  double slab_bottom_slide_thickness;

  int num_spheres;
  int num_measures;

  double d_beam;
  double sphere_with_rc;
  double sphere_with_tc;

  double m_r, m_t, m_u;

  double lambda;
  double as_r, ad_r, ae_r, aw_r, rd_r, rw_r, rstd_r, f_r;
  double as_t, ad_t, ae_t, aw_t, rd_t, rw_t, rstd_t, f_t;
  double ur1_lost, uru_lost, ut1_lost, utu_lost;
  double d_sphere_r, d_sphere_t;
} IAD_measure_type;


typedef struct invert_type
{
  double a;
  double b;
  double g;

  int found;
  int search;
  int metric;
  double tolerance;
  double MC_tolerance;
  double final_distance;
  int iterations;
  int error;

  struct AD_slab_type slab;
  struct AD_method_type method;

  double default_a;
  double default_b;
  double default_g;
  double default_ba;
  double default_bs;
  double default_mua;
  double default_mus;

} IAD_invert_type;



typedef int search_type;

typedef int boolean_type;

typedef int illumination_type;

typedef struct guess_t
{
  double distance;
  double a;
  double b;
  double g;
} guess_type;

extern double FRACTION;
